BEGIN
   DECLARE
      V_COUNT NUMBER;
   BEGIN
      V_COUNT := 0;
      BEGIN
         SELECT COUNT(*)
           INTO V_COUNT
           FROM USER_SCHEDULER_JOBS
          WHERE JOB_NAME = 'JOB_VENDAS_DASHBOARD';
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      IF V_COUNT = 0 THEN
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_VENDAS_DASHBOARD',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CARDS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=45',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar vendas nas tabelas dos Dashboards'
         );
      ELSE
         DBMS_SCHEDULER.DROP_JOB(JOB_NAME => 'JOB_VENDAS_DASHBOARD');
         DBMS_SCHEDULER.CREATE_JOB (
            job_name        => 'JOB_VENDAS_DASHBOARD',
            job_type        => 'PLSQL_BLOCK',
            job_action      => 'BEGIN DASHBOARD_VND_CARDS(); END;',
            start_date      => SYSDATE,
            repeat_interval => 'FREQ=MINUTELY;INTERVAL=45',
            end_date        => NULL,
            enabled         => TRUE,
            comments        => 'Job criado para atualizar vendas nas tabelas dos Dashboards'
         );
      END IF;
   END;
END;

/